
        function EC8DesignSpectrum(agR, importance, q, soil) {
            this.agR = agR;
            this.importance = importance;
            this.q = q;
            this.soil = soil;
            this.beta = 0.2;

            this.ApplyParameters = function () {
                switch (this.soil) {
                    case "A":
                        this.S = 1.0;
                        this.TB = 0.15;
                        this.TC = 0.40;
                        this.TD = 2.5;
                        break;
                    case "B":
                        this.S = 1.2;
                        this.TB = 0.15;
                        this.TC = 0.50;
                        this.TD = 2.5;
                        break;
                    case "C":
                        this.S = 1.15;
                        this.TB = 0.2;
                        this.TC = 0.6;
                        this.TD = 2.5;
                        break;
                    case "D":
                        this.S = 1.35;
                        this.TB = 0.2;
                        this.TC = 0.8;
                        this.TD = 2.5;
                        break;
                    case "E":
                        this.S = 1.4;
                        this.TB = 0.15;
                        this.TC = 0.5;
                        this.TD = 2.5;
                        break;
                    default:
                        this.S = 0;
                        this.TB = 0.15;
                        this.TC = 0.5;
                        this.TD = 2.5;
                        break;
                }

                switch (this.importance) {
                    case "I":
                        this.gamma1 = 0.8;
                        break;
                    case "II":
                        this.gamma1 = 1.0;
                        break;
                    case "III":
                        this.gamma1 = 1.2;
                        break;
                    case "IV":
                        this.gamma1 = 1.4;
                        break;
                    default:
                        this.gamma1 = 0;
                        break;
                }

                this.Sd = function (T) {
                    switch (true) {
                        case (T < this.TB):
                            return this.agR * this.gamma1  * this.S * ((2 / 3) + (T / this.TB) * ((2.5 / this.q) - (2 / 3)));
                            break;
                        case (T >= this.TB && T <= this.TC):
                            return this.agR * this.gamma1 * this.S * (2.5 / this.q);
                            break;
                        case (T > this.TC && T < this.TD):
                            return Math.max(this.agR * this.gamma1 * this.S * (2.5 / this.q) * (this.TC / T), this.beta * this.agR);
                            break;
                        case (T >= this.TD):
                            return Math.max(this.agR * this.gamma1 * this.S * (2.5 / this.q) * (this.TC * this.TD / (T * T)), this.beta * this.agR);
                            break;
                        default:
                            return 3;
                            break;



                    }


                    return 2
                }


            }

        }
